"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.build = void 0;
const rollup_plugin_filesize_1 = __importDefault(require("rollup-plugin-filesize"));
const plugin_json_1 = __importDefault(require("@rollup/plugin-json"));
const plugin_commonjs_1 = __importDefault(require("@rollup/plugin-commonjs"));
const plugin_node_resolve_1 = __importDefault(require("@rollup/plugin-node-resolve"));
const rollup_plugin_terser_1 = require("rollup-plugin-terser");
const plugin_babel_1 = __importDefault(require("@rollup/plugin-babel"));
const extensions = ['.js', '.jsx', '.ts', '.tsx'];
function build(input, outputOrOutputs, otherOptions = { withMin: false }) {
    const { external, withMin } = otherOptions;
    const config = {
        input,
        external,
        plugins: [
            plugin_json_1.default(),
            plugin_node_resolve_1.default({ extensions }),
            plugin_commonjs_1.default(),
            plugin_babel_1.default({ extensions, include: ['src/**/*'], babelHelpers: 'bundled' }),
        ],
        output: [],
    };
    const outputs = [].concat(outputOrOutputs);
    const copy = outputs.map((item) => {
        return Object.assign({}, item);
    });
    if (withMin) {
        copy.forEach((item) => {
            if (item.file)
                item.file = item.file.replace(/.js$/, '.min.js');
            item.sourcemap = false;
        });
        config.plugins.push(rollup_plugin_terser_1.terser());
        otherOptions = Object.assign(Object.assign({}, otherOptions), { withMin: false });
    }
    else {
        copy.forEach((item) => {
            item.sourcemap = true;
        });
    }
    config.plugins.push(rollup_plugin_filesize_1.default());
    config.output = copy;
    return withMin
        ? [build(input, outputOrOutputs, otherOptions), config]
        : config;
}
exports.build = build;
//# sourceMappingURL=index.js.map